function [En] = calcul_Energy(VSST,nc)
%Compute the energy associated with nc components
 [Tsort,IND] = sort(abs(VSST(:)),'descend');
 siz = size(VSST);
 [I,J] = ind2sub(siz,IND(1:nc*siz(2)));
 loc= zeros(siz);
 for k = 1:length(I),
  loc(I(k),J(k)) = 1;
 end
 
 B = zeros(siz+2);
 B(2:siz(1)+1,2:siz(2)+1) = loc;
 
 A = loc+B(1:siz(1),1:siz(2))+B(1:siz(1),2:siz(2)+1)+B(1:siz(1),3:siz(2)+2)+...
     B(2:siz(1)+1,1:siz(2))+B(2:siz(1)+1,2:siz(2)+1)+B(2:siz(1)+1,3:siz(2)+2)+...
     B(3:siz(1)+2,1:siz(2))+B(3:siz(1)+2,2:siz(2)+1)+B(3:siz(1)+2,3:siz(2)+2);
 
 %removing points not connected to two neighbours
 loc1 = zeros(siz);
 for k = 1:siz(1),
  for k1 = 1:siz(2),
   %A = sum(sum(loc(k-1:k+1,k1-1:k1+1)));
   loc1(k,k1) = (A(k,k1) <= 4)*(A(k,k1) >= 3)*loc(k,k1);    
  end
 end

 A1 = (abs(VSST).*loc1).^2;
 En = sum(A1(:))/sum(sum(abs(VSST).^2));
end

