function [sp1_s1,sp2_s1,sp3_s1,sp4_s1,sp5_s1,integ1,integ2,integ3,integ4,integ5] = demod(s1,VSST_s1,VSST1_s1,VSST2_s1,VSST3_s1,VSST4_s1,...
                                                      Nfft1,Nfft2,Nfft3,Nfft4,Nfft5,t,N,jump)   
%Computation of the ridges with no regularization, effect of zero padding 
 beta   = 0;
 lambda = 0;
 %for signal s1
 [Cs2, Es] = exridge(VSST_s1,lambda,beta,jump);
 [Cs21,Es] = exridge(VSST1_s1,lambda,beta,jump);
 [Cs22,Es] = exridge(VSST2_s1,lambda,beta,jump);
 [Cs23,Es] = exridge(VSST3_s1,lambda,beta,jump);
 [Cs24,Es] = exridge(VSST4_s1,lambda,beta,jump);

 %improvement with EMD
%  [indmin,indmax,indzer] = extrbis(Cs2-1);
% 
%  if (length(indmin)>=2)&&(length(indmax)>=2)
%   [imf]   = emdbis(Cs2-1);
%   R_vsst0  = Cs2-1-imf(1,:);
%  else
%   R_vsst0  = Cs2-1;  
%  end
%  
%  [indmin,indmax,indzer] = extrbis(Cs21-1);
%  if (length(indmin)>=2)&&(length(indmax)>=2)
%   [imf]   = emdbis(Cs21-1);
%   R_vsst1  = Cs21-1-imf(1,:);
%  else
%   R_vsst1  = Cs21-1;  
%  end
%  
%  [indmin,indmax,indzer] = extrbis(Cs22-1);
%  if (length(indmin)>=2)&&(length(indmax)>=2)
%   [imf]   = emdbis(Cs22-1);
%   R_vsst2  = Cs22-1-imf(1,:);
%  else
%   R_vsst2  = Cs22-1;  
%  end
%  
%  [indmin,indmax,indzer] = extrbis(Cs23-1);
%  if (length(indmin)>=2)&&(length(indmax)>=2)
%   [imf]   = emdbis(Cs23-1);
%   R_vsst3  = Cs23-1-imf(1,:);
%  else
%   R_vsst3  = Cs23-1;  
%  end
%  
%  
%  [indmin,indmax,indzer] = extrbis(Cs24-1);
%  if (length(indmin)>=2)&&(length(indmax)>=2)
%   [imf]   = emdbis(Cs24-1);
%   R_vsst4  = Cs24-1-imf(1,:);
%  else
%   R_vsst4  = Cs24-1;  
%  end
 
 R_vsst0  = Cs2-1;
 R_vsst1  = Cs21-1;  
 R_vsst2  = Cs22-1; 
 R_vsst3  = Cs23-1; 
 R_vsst4  = Cs24-1;
 
 %numerical integration of R_vsst0 and demodulated signal
 integ1 = cumtrapz(t,N/Nfft1*R_vsst0);
 sp1_s1 = s1.*exp(-2*1i*pi*(integ1-100.*t));
 
 %numerical integration of R_vsst1
 integ2 = cumtrapz(t,N/Nfft2*R_vsst1);
 sp2_s1 = s1.*exp(-2*1i*pi*(integ2-100.*t));
 
 %numerical integration of R_vsst2
 integ3 = cumtrapz(t,N/Nfft3*R_vsst2);
 sp3_s1 = s1.*exp(-2*1i*pi*(integ3-100.*t));
 
 %numerical integration of R_vsst3
 integ4  = cumtrapz(t,N/Nfft4*R_vsst3);
 sp4_s1 = s1.*exp(-2*1i*pi*(integ4-100.*t));
 
 %numerical integration of R_vsst3
 integ5  = cumtrapz(t,N/Nfft5*R_vsst4);
 sp5_s1 = s1.*exp(-2*1i*pi*(integ5-100.*t));
end 