%% Signal
N  = 1024;
t  = (0:N-1)/N;
fs = 0:N/2-1;

a = 2;
s = a.*exp(2*pi*1i*(130*t+100*t.^2));

%% Parameters
gamma = 0.01;
sigma = 0.04;

% Choice of time and frequency bins
ft = 1:N/2;
bt = 1:N;

% reconstruction parameters
lambda = 0.2;
beta   = 0.1;

%% Compute TF transforms
[STFT,SST,VSST,omega,tau,omega2] = sst2(s,gamma,sigma,ft,bt);

%Figure A
imagesc(t,fs,abs(VSST));
set(gca,'YDir','normal')
colormap(1-gray)
pause

[Cs, Es] = exridge(VSST,lambda,beta);

%computation of the demodulated signal (without using EMD)  
sp = s.*exp(-2*1i*pi*(Cs-1).*t/2);
[STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma,ft,bt);
 
%Figure B
imagesc(t,fs,abs(VSST1));
set(gca,'YDir','normal')
colormap(1-gray)
pause
 
%computation of the demodulated signal using ridges computed with EMD 
[indmin,indmax,indzer] = extrbis(Cs-1);

if (length(indmin)>=2)&&(length(indmax)>=2)
 [imf]   = emdbis(Cs-1);
 R_vsst  = Cs-1-imf(1,:);
else
 R_vsst  = Cs-1;  
end
sp = s.*exp(-2*1i*pi*(R_vsst).*t/2);
 
[STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma,ft,bt);

% Figure C
imagesc(t,fs,abs(VSST1));
set(gca,'YDir','normal')
colormap(1-gray)
pause


