
%% Signal
N = 1024;
t = (0:N-1)/N;

a  = 2;
s1 = a.*exp(2*pi*1i*(250*t+100*t.^3));
s2 = a.*exp(2*pi*1i*(130*t+100*t.^2));
s3 = a.*exp(2*pi*1i*(90*t+0.2*cos(3*pi*t)));
s  = s1+s2+s3;

%% Parameters
gamma = 0.01;
sigma = 0.04;

% Choice of time and frequency bins
ft = 1:N/2;
bt = 1:N;

% reconstruction parameters
lambda = 0.2;
beta   = 0.1;


%% Compute TF transforms

[STFT,SST,VSST,omega,tau,omega2] = sst2(s,gamma,sigma,ft,bt);

%Figure A
fs = 0:N/2-1;
imagesc(t,fs,abs(VSST));
set(gca,'YDir','normal')
colormap(1-gray)
pause

nr    = 3; %number of modes to be detected
clwin = 10;   
[Cs, Es] = exridge_mult(VSST,nr,lambda,beta,clwin);

for k = 1:nr,
 [indmin,indmax,indzer] = extrbis(Cs(k,:)-1);

 if (length(indmin)>=2)&&(length(indmax)>=2)
  [imf]   = emdbis(Cs(k,:)-1);
  R_vsst  = Cs(k,:)-1-imf(1,:);
 else
  R_vsst  = Cs(k,:)-1;  
 end
 
 %numerical integration of R_vsst
 integ = cumtrapz(t,R_vsst);
 sp = s.*exp(-2*1i*pi*(integ-100.*t));
 
 %perform the sunchrosqueezing transform on the demodulated modes 
 [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma,ft,bt);
  
  %Figure B C D
  imagesc(t,fs,abs(VSST1));
  set(gca,'YDir','normal')
  colormap(1-gray)
  pause
end

