function Fig9_New(cas)
clc; 
clear all; 
close all;

%set(0,'DefaultAxesFontSize',15);

N = 1024;
fs = 0:N/2;

% Parameters
gamma = 0.01;
sigma = [0.01:0.01:0.2];
index = N/8+1:7*N/8;
d = 10;
clwin = 10;
lambda = 0.02;
nmodes = 3;

t = (0:N-1)/N;f = 0:N/2-1; 

% Choice of time and frequency bins
ft =1:N/2;bt=1:N;

%% Tests signals 1
if (cas == 1)
 a  = 2;%exp(-8*(t-0.5).^2);
 s1 = a.*sin(2*pi*(250*t+100*t.^3));
 s2 = a.*sin(2*pi*(130*t+100*t.^2));
 s3 = a.*sin(2*pi*(90*t+0.2*cos(3*pi*t)));
 s = s1+s2+s3;
 nr = 3;
else
%% Test signal 2
 a = 2;%exp(-8*(t-0.5).^2);
 s1 = a.*sin(2*pi*(330*t+16*cos(3*pi*t)));
 s2 = a.*sin(2*pi*(190*t+9*cos(3*pi*t)));
 s = s1+s2;
 nr = 2;
end 
%% Test signal with noise

SNR = 0:15;
d = 0;

snr_direct = zeros(length(SNR),nr);
snr_demod  = zeros(length(SNR),nr);

for k =1:length(SNR),
   k
   noise=randn(1,length(s));
   %Scale the input signal accordingly for the given SNR.
   scaledSignal = std(noise)/std(s)*(sqrt(10^(SNR(k)/10)))*s;
   %calculate Signal power and noise power
   signalPower = (norm(scaledSignal)^2)/length(scaledSignal);
   noisePower = (norm(noise)^2)/length(noise);
 
   %Calculate Signal to noise ratio for the scaledSignal and generated Noise
   SNRratio = signalPower/noisePower;
 
   %Add the scaled signal with the generated noise
   sW = scaledSignal+noise;
   Ren = zeros(length(sigma),1);
   Sha = zeros(length(sigma),1);
   s0 = sW;
   for j = 1:length(sigma)
    [STFT,SST,VSST,omega,tau,omega2] = sst2(s0,gamma,sigma(j),ft,bt);
    Ren(j) =renyi_entropy(abs(VSST),t,f',3);
    Sha(j) =renyi_entropy(abs(VSST),t,f',1);
   end
   %optimal sigma
   sigma_optR = sigma(Ren==min(Ren));
   
   
   [STFT,SST,VSST,omega,tau,omega2] = sst2(s0,gamma,sigma_optR,ft,bt);
   
   [Cs, Es] = exridge_mult(VSST,nr,lambda,beta,clwin);
 
   %direct reconstruction using ridges determined from VSST  
   imf_direct = sigma_optR*recmodes(VSST,Cs,d);
   
   if (cas == 1)
    snr_direct(k,:) =  [snr(s1(index),imf_direct(1,index)-s1(index))... 
                        snr(s2(index),imf_direct(2,index)-s2(index))...
                        snr(s3(index),imf_direct(3,index)-s3(index))];
   else
    snr_direct(k,:) =  [snr(s1(index),imf_direct(1,index)-s1(index))... 
                        snr(s2(index),imf_direct(2,index)-s2(index))];
   end
  
   %reconstruction using smooth ridges determined from VSST and smoothed with EMD,
   %and then demodulation 
   imf_demod = zeros(nr,N);
 
   for q = 1:nr,
    [indmin,indmax,indzer] = extrbis(Cs(q,:)-1);
    if (length(indmin)>=2)&&(length(indmax)>=2)
     [imf]   = emdbis(Cs(k,:)-1);
     R_vsst  = Cs(q,:)-1-imf(1,:);
    else
     R_vsst  = Cs(q,:)-1;  
    end
    %numerical integration of Y, and demodulation
    integ = cumtrapz(t,R_vsst);
    sp = s.*exp(-2*1i*pi*(integ-100.*t));
    for j = 1:length(sigma)
     [STFT,SST,VSST,omega,tau,omega2] = sst2(sp,gamma,sigma(j),ft,bt);
     Ren(j) =renyi_entropy(abs(VSST),t,f',3);
     Sha(j) =renyi_entropy(abs(VSST),t,f',1);
    end
    %optimal sigma
    sigma_opt_demod = sigma(Ren==min(Ren));
    %perform the sunchrosqueezing transform on the demodulated modes 
    [STFT1,SST1,VSST1,omega,tau,omega2] = sst2(sp,gamma,sigma_opt_demod,ft,bt);
    %we extract q ridges
    [C, Es] = exridge_mult(SST1,q,lambda,beta,clwin);
   
    %reconstruction of mode k, using the SST
    imf2 = sigma(p)*recmodes(SST1,C(q,:),d);
    imf2 = imf2.*exp(2*1i*pi*(integ-100.*t));
    imf_demod(q,:) = imf2; 
   end
 
  if (cas == 1)
   snr_demod(k,:) = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
                     snr(s2(index),imf_demod(2,index)-s2(index)) ...
                     snr(s3(index),imf_demod(3,index)-s3(index))];
  else
   snr_demod(k,:) = [snr(s1(index),imf_demod(1,index)-s1(index)) ...
                     snr(s2(index),imf_demod(2,index)-s2(index))];
  end    
end
clear figure
plot(SNR,snr_demod(:,1),SNR,snr_direct(:,1),'--');%high frequency mode
figure
plot(SNR,snr_demod(:,2),SNR,snr_direct(:,2),'--');
if cas == 1
 figure   
 plot(SNR,snr_demod(:,3),SNR,snr_direct(:,3),'--');
end
end
 